/*
 * Copyright 2016 - 2025 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <keel/context.hpp>

#include <turbine/context.hpp>
#include <turbine/turbine.hpp>

namespace turbine {

class Context final {
	public:
		UpdateHandler updateHandler = [](Context&) -> int {return 0;};
		keel::Context keelCtx;
		KeyEventHandler keyEventHandler = nullptr;
		ox::AnyPtr applicationData;

		// GBA impl data /////////////////////////////////////////////////////////
		bool running = true;

		Context() noexcept = default;
		Context(Context &other) noexcept = delete;
		Context(Context const &other) noexcept = delete;
		Context(Context const &&other) noexcept = delete;

};

}
